'*******************************************************************************************************************
'Config
'-------------------------------------------------------------------------------------------------------------------
'Configuration vars and constants
'*******************************************************************************************************************

'----------------------
'Sprites static data
'----------------------
'Sprite structure
const SPRITESTATICSTRUCT as ubyte = 11

const SPRITESTATICCHRRIGHT as ubyte = 0
const SPRITESTATICCHRLEFT as ubyte = 1
const SPRITESTATICCHRJUMPRIGHT as ubyte = 2
const SPRITESTATICCHRJUMPLEFT as ubyte = 3
const SPRITESTATICCHRDIE as ubyte = 4
const SPRITESTATICSIZEY as ubyte = 5
const SPRITESTATICSIZEX as ubyte = 6
const SPRITESTATICFRAMES as ubyte = 7
const SPRITESTATICFRAMESJUMP as ubyte = 8
const SPRITESTATICFRAMESDIE as ubyte = 9
const SPRITESTATICTYPE as ubyte = 10

'----------------------
'Block static data
'----------------------
'Tile structure
const BLOCKSTATICSTRUCT as ubyte = 4

const BLOCKSTATICCHR1 as ubyte = 0
const BLOCKSTATICCHR2 as ubyte = 1
const BLOCKSTATICCHR3 as ubyte = 2
const BLOCKSTATICCOLOR as ubyte = 3

'----------------------
'Tiles static data
'----------------------
'Tile structure
const TILESTATICSTRUCT as ubyte = 6

const TILESTATICBLOCK1 as ubyte = 0
const TILESTATICBLOCK2 as ubyte = 1
const TILESTATICBLOCK3 as ubyte = 2
const TILESTATICTYPE1 as ubyte = 3
const TILESTATICTYPE2 as ubyte = 4
const TILESTATICTYPE3 as ubyte = 5

'Type of tile
const TILEEMPTY as ubyte = 0 'Empty (background, black)
const TILESOLID as ubyte = 1 'Solid (User cannot tresspass the tile - floor, wall, etc)
const TILEFRONT as ubyte = 2 'Front (User passes behind the tile, hiding)
const TILEBACK as ubyte = 3 'Back (User passes in front of tile using the mask)
const TILEDIE as ubyte = 4 'Die (User dies when touching the tile)
const TILESOLIDTRESPASS as ubyte = 5 'Solid trespass (User can tresspass if jumping from below the tile, but not when coming from above - special floor)

'Tiles
const MAPTILEEMPTY as ubyte = 0 'Empty
const MAPTILEEMPTYSOLID as ubyte = 22 'Empty, but cannot be tresspassed, used to put doors/final princess on it (Be careful to have this tile always in this number)

'CHR
Const CHRSPACE As uByte = 32 'Space
Const CHRNUM0 As uByte = 36 'Number 0 in the font set

'----------------------
'Map data
'----------------------
'Map structure
const MAPSTRUCT as ubyte = 1

const MAPTILE as ubyte = 0

'----------------------
'Objects static data
'----------------------
'Object structure
const OBJECTSTATICSTRUCT as ubyte = 4

const OBJECTSTATICCHR as ubyte = 0
const OBJECTSTATICSIZEY as ubyte = 1
const OBJECTSTATICSIZEX as ubyte = 2
const OBJECTSTATICTYPE as ubyte = 3

'----------------------
'Map
'----------------------
Const MAPHEIGHT As uByte = 5
Const MAPWIDTH As uByte = 5
Const STARTSCREENY As uByte = 1 'Initial game screen Y
Const STARTSCREENX As uByte = 0 'Initial game screen X

'----------------------
'Screen
'----------------------
Const MAPSCREENHEIGHT As uByte = 6
Const MAPSCREENWIDTH As uByte = 9
Const TILESIZE As uByte = 3 '3x3
Const SCREENOFFSETY As uByte = 0
Const SCREENOFFSETX As uByte = 3

'----------------------
'Scoreboard
'----------------------
Const LIVESY As uByte = 19 'Y position on screen of lives counter
Const LIVESX As uByte = 0 'X position on screen of lives counter
Const OBJECTSY As uByte = 19 'Y position on screen of objects collected
Const OBJECTSX As uByte = 12 'X position on screen of objects collected
Const MAXLIVES As uByte = 4 'Max number of lives

'----------------------
'Sprites dynamic data
'----------------------
'Current and Old sprite dynamic data
'Sprite structure
const SPRITESTRUCT as ubyte = 19

const SPRITEID as ubyte = 0
const SPRITEY as ubyte = 1
const SPRITEX as ubyte = 2
const SPRITEINITY as ubyte = 3
const SPRITEINITX as ubyte = 4
const SPRITEINITDIRX as ubyte = 5
const SPRITEMINY as ubyte = 6
const SPRITEMINX as ubyte = 7
const SPRITEMAXY as ubyte = 8
const SPRITEMAXX as ubyte = 9
const SPRITEFRAME as ubyte = 10
const SPRITEFRAMEJUMP as ubyte = 11
const SPRITEFRAMEDIE as ubyte = 12
const SPRITEDIRY as ubyte = 13
const SPRITEDIRX as ubyte = 14
const SPRITECOLOR as ubyte = 15
const SPRITESTATUS as ubyte = 16
const SPRITEOLDY as ubyte = 17
const SPRITEOLDX as ubyte = 18

'----------------------
'Objects dynamic data
'----------------------
'Current objects dynamic data
'Object structure
const OBJECTSTRUCT as ubyte = 9

const OBJECTID as ubyte = 0
const OBJECTOBJID as ubyte = 1
const OBJECTSCREENY as ubyte = 2
const OBJECTSCREENX as ubyte = 3
const OBJECTY as ubyte = 4
const OBJECTX as ubyte = 5
const OBJECTCOLOR as ubyte = 6
const OBJECTSTATUS as ubyte = 7
const OBJECTLINKEDID as ubyte = 8

'----------------------
'Others
'----------------------
'Directions
const DIRNONE as ubyte = 0
'X Directions
const DIRLEFT as ubyte = 1
const DIRRIGHT as ubyte = 2
'Y Directions
const DIRUP as ubyte = 3
const DIRDOWN as ubyte = 4

'Type of sprite
const HERO as ubyte = 0
const ENEMYHORIZONTALFLOOR as ubyte = 1
const ENEMYFLY as ubyte = 2
const ENEMYSTALACTITE as ubyte = 3
const ENEMYFISH as ubyte = 4

'Number of entities
const NUMSPRITES as ubyte = 2 'Number of sprites by screen: Hero + Enemy
const NUMOBJECTS as ubyte = 11 'Number of objects in map
const NUMOBJECTSCOLLECTABLE as ubyte = 3 'Number of objects collectable

'Sprites status
const SPRITEINACTIVE as ubyte = 0
const SPRITEACTIVE as ubyte = 1
const SPRITEJUMPING as ubyte = 2
const SPRITEFALLING as ubyte = 3
const SPRITEDYING as ubyte = 4

'Type of object
const OBJECTLIFE as ubyte = 0
const OBJECTKEY as ubyte = 1
const OBJECTDOOR as ubyte = 2
const OBJECTFINAL as ubyte = 3 'The princess

'Object status
const OBJECTINACTIVE as ubyte = 0
const OBJECTACTIVE as ubyte = 1
const OBJECTCOLLECTED as ubyte = 2
const OBJECTUSED as ubyte = 3

'Move
const MOVECHR as ubyte = 1 'Sprites move 1 charcater
const SPRITEFIRSTFRAME as ubyte = 0 'Sprite first frame, always 0

'Jump
const JUMPSTEPS as ubyte = 9 'Parabol jump has 9 steps

'Fall
const FALLHIGHMAX as ubyte = 10 'If hero falls more than 10 characters dies

'Boolean
const TRUE as ubyte = 1
const FALSE as ubyte = 0

'Colors
const COLORBLACK as ubyte = 0
const COLORBLUE as ubyte = 1
const COLORRED as ubyte = 2
const COLORMAGENTA as ubyte = 3
const COLORGREEN as ubyte = 4
const COLORCYAN as ubyte = 5
const COLORYELLOW as ubyte = 6
const COLORWHITE as ubyte = 7
'Bright
const COLORBRIGHT as ubyte = 64
